
TYPO3.Flow - Bug # 28213

Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: Configuration
Created: 2011-07-14 Assigned To:
Updated: 2012-05-15 Due date:
PHP Version:
Has patch:
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: Sites Configuration should overrule package Configuration
Description

This is not really a bug, more a missing feature, but I think, this is rather important:
It's currently not possible to override configuration from within a Sites Package.

For example:
If you want to change the default authentication redirect URI, you could add following to the Settings.yaml of your site package:

TYPO3:

   # redirect to login page when trying to access a protected page:
  FLOW3:
    security:
      authentication:
        providers:
          DefaultProvider:
            entryPoint:
              WebRedirect:
                uri: login.html

But this will be overriden by the respective configuration in the Settings.yaml of the TYPO3 package.

Of course, you can copy those lines to the global Settings.yaml, but our goal should be to be able to provide all required settings with
your site package..

It should be possible to somehow configure the order of how package settings are merged..

Note: I'm setting the target version to 1.0 beta 1 because this would probably be a breaking change afterwards..

Related issues:
related to TYPO3.Flow - Bug # 36965: Packages are ordered reverse in configur... Resolved 2012-05-08
related to TYPO3.Flow - Bug # 28672: Inconsistent configuration overrides for... Resolved 2011-08-02
related to TYPO3.Flow - Feature # 30258: Support optional package dependencies New 2011-09-24

Associated revisions
Revision 2fba45eb - 2012-05-09 15:53 - Karsten Dambekalns

[TASK] Add Doctrine.ORM to the dependencies
Change-Id: I50bb3c71ae59edd619155f318a0f6dff4487e37e
Related: #28213
Releases: 1.1

Revision df6b2a21 - 2012-05-14 17:29 - Stephan Schuler

[FEATURE] Order package loading by dependencies

This change simply reorders the internal packages arrays
of the PackageManager in a way that if PackageA depends
on PackageB, PackageA comes later then PackageB when
iterating over those arrays.

This change does not introduce a sophisticated dependency
management, however it makes sure to be be able to load
configuration settings in the correct order.

Change-Id: I5c9531ceaa7c08c8b48d9e572ff9a316345b1b74
Resolves: #28213
Releases: 1.1

History
#1 - 2011-07-15 13:37 - Stephan Schuler

I agree that there has to be a certain ordre of packages. But I don't want to have all that stuff in the sites package.

As some projects will consist of many different parts, it should be allowed to split up such projects into different packages.
Especially, I want to be able to create a package "MyPackage" containing the functionality. This one may become public available. And I want to create
another package "MyPackageCustom" that contains project specific changes like custom layout and settings.

So it should be possible to configure package dependencies in some way.
I would prefer to add package dependencies to the Package.php. That would simply allow the PackageManager to "usort" its internal array of
packageInterfaces.

#2 - 2011-07-21 12:20 - Stephan Schuler

This relates to https://review.typo3.org/#change,3449.

#3 - 2011-08-04 08:38 - Sebastian Kurfuerst
- Target version changed from 1.0 beta 1 to 1.0 beta 2

moving to beta2, as it is an additional feature as behavior right now is undefined.

#4 - 2011-09-07 14:18 - Mr. Hudson
- Status changed from New to Under Review
Patch set 5 of change I5c9531ceaa7c08c8b48d9e572ff9a316345b1b74 has been pushed to the review server.
It is available at http://review.typo3.org/3449

#5 - 2011-09-07 14:39 - Mr. Hudson

Patch set 6 of change I5c9531ceaa7c08c8b48d9e572ff9a316345b1b74 has been pushed to the review server.
It is available at http://review.typo3.org/3449

#6 - 2011-09-09 15:17 - Robert Lemke
- Target version changed from 1.0 beta 2 to 1.0.0

#7 - 2011-10-20 01:46 - Karsten Dambekalns
- Target version changed from 1.0.0 to 1.0.1

#8 - 2011-10-21 13:20 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#9 - 2011-11-22 12:48 - Karsten Dambekalns
- Target version changed from 1.0.1 to 1.0.2

#10 - 2011-12-22 08:51 - Karsten Dambekalns
- Target version changed from 1.0.2 to 1.0.3

#11 - 2012-03-07 18:52 - Karsten Dambekalns
- Target version changed from 1.0.3 to 1.0.4

#12 - 2012-04-18 22:49 - Karsten Dambekalns
- Target version changed from 1.0.4 to 1.0.5

#13 - 2012-04-23 13:54 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#14 - 2012-04-23 14:03 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#15 - 2012-05-08 12:23 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#16 - 2012-05-08 14:02 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449
#17 - 2012-05-08 14:05 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#18 - 2012-05-08 14:05 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#19 - 2012-05-08 14:14 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#20 - 2012-05-09 15:54 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#21 - 2012-05-09 16:10 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#22 - 2012-05-09 17:06 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#23 - 2012-05-14 17:29 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/3449

#24 - 2012-05-15 02:38 - Stephan Schuler
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:df6b2a2113bd9d680985b7d12211935ff4a4952d.
